Index: code/branches/hud/visual_studio/vc8/orxonox.vcproj
===================================================================
--- code/branches/hud/visual_studio/vc8/orxonox.vcproj	(revision 1590)
+++ code/branches/hud/visual_studio/vc8/orxonox.vcproj	(revision 1601)
@@ -189,55 +189,4 @@
 			</File>
 			<Filter
-				Name="hud"
-				>
-				<File
-					RelativePath="..\..\src\orxonox\hud\HUD.cc"
-					>
-				</File>
-				<File
-					RelativePath="..\..\src\orxonox\hud\HUDBar.cc"
-					>
-				</File>
-				<File
-					RelativePath="..\..\src\orxonox\hud\HUDFPSText.cc"
-					>
-				</File>
-				<File
-					RelativePath="..\..\src\orxonox\hud\HUDOverlay.cc"
-					>
-				</File>
-				<File
-					RelativePath="..\..\src\orxonox\hud\HUDRTRText.cc"
-					>
-				</File>
-				<File
-					RelativePath="..\..\src\orxonox\hud\HUDSpeedBar.cc"
-					>
-				</File>
-				<File
-					RelativePath="..\..\src\orxonox\hud\HUDText.cc"
-					>
-				</File>
-				<File
-					RelativePath="..\..\src\orxonox\hud\Navigation.cc"
-					>
-					<FileConfiguration
-						Name="Debug|Win32"
-						>
-						<Tool
-							Name="VCCLCompilerTool"
-						/>
-					</FileConfiguration>
-				</File>
-				<File
-					RelativePath="..\..\src\orxonox\hud\RadarObject.cc"
-					>
-				</File>
-				<File
-					RelativePath="..\..\src\orxonox\hud\RadarOverlayElement.cc"
-					>
-				</File>
-			</Filter>
-			<Filter
 				Name="objects"
 				>
@@ -452,12 +401,4 @@
 				<File
 					RelativePath="..\..\src\orxonox\tools\WindowEventListener.cc"
-					>
-				</File>
-			</Filter>
-			<Filter
-				Name="console"
-				>
-				<File
-					RelativePath="..\..\src\orxonox\console\InGameConsole.cc"
 					>
 				</File>
@@ -487,4 +428,60 @@
 				</File>
 			</Filter>
+			<Filter
+				Name="overlays"
+				>
+				<File
+					RelativePath="..\..\src\orxonox\overlays\OrxonoxOverlay.cc"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\orxonox\overlays\OverlayGroup.cc"
+					>
+				</File>
+				<Filter
+					Name="console"
+					>
+					<File
+						RelativePath="..\..\src\orxonox\overlays\console\InGameConsole.cc"
+						>
+					</File>
+				</Filter>
+				<Filter
+					Name="hud"
+					>
+					<File
+						RelativePath="..\..\src\orxonox\overlays\hud\HUDBar.cc"
+						>
+					</File>
+					<File
+						RelativePath="..\..\src\orxonox\overlays\hud\HUDFPSText.cc"
+						>
+					</File>
+					<File
+						RelativePath="..\..\src\orxonox\overlays\hud\HUDNavigation.cc"
+						>
+					</File>
+					<File
+						RelativePath="..\..\src\orxonox\overlays\hud\HUDRTRText.cc"
+						>
+					</File>
+					<File
+						RelativePath="..\..\src\orxonox\overlays\hud\HUDSpeedBar.cc"
+						>
+					</File>
+					<File
+						RelativePath="..\..\src\orxonox\overlays\hud\HUDText.cc"
+						>
+					</File>
+					<File
+						RelativePath="..\..\src\orxonox\overlays\hud\RadarObject.cc"
+						>
+					</File>
+					<File
+						RelativePath="..\..\src\orxonox\overlays\hud\RadarOverlayElement.cc"
+						>
+					</File>
+				</Filter>
+			</Filter>
 		</Filter>
 		<Filter
@@ -514,52 +511,4 @@
 			</File>
 			<Filter
-				Name="hud"
-				>
-				<File
-					RelativePath="..\..\src\orxonox\hud\HUD.h"
-					>
-				</File>
-				<File
-					RelativePath="..\..\src\orxonox\hud\HUDBar.h"
-					>
-				</File>
-				<File
-					RelativePath="..\..\src\orxonox\hud\HUDFPSText.h"
-					>
-				</File>
-				<File
-					RelativePath="..\..\src\orxonox\hud\HUDOverlay.h"
-					>
-				</File>
-				<File
-					RelativePath="..\..\src\orxonox\hud\HUDRTRText.h"
-					>
-				</File>
-				<File
-					RelativePath="..\..\src\orxonox\hud\HUDSpeedBar.h"
-					>
-				</File>
-				<File
-					RelativePath="..\..\src\orxonox\hud\HUDText.h"
-					>
-				</File>
-				<File
-					RelativePath="..\..\src\orxonox\hud\Navigation.h"
-					>
-				</File>
-				<File
-					RelativePath="..\..\src\orxonox\hud\OverlayElementFactories.h"
-					>
-				</File>
-				<File
-					RelativePath="..\..\src\orxonox\hud\RadarObject.h"
-					>
-				</File>
-				<File
-					RelativePath="..\..\src\orxonox\hud\RadarOverlayElement.h"
-					>
-				</File>
-			</Filter>
-			<Filter
 				Name="objects"
 				>
@@ -682,18 +631,70 @@
 			</Filter>
 			<Filter
-				Name="console"
-				>
-				<File
-					RelativePath="..\..\src\orxonox\console\InGameConsole.h"
+				Name="tolua"
+				>
+				<File
+					RelativePath="..\..\src\orxonox\tolua\tolua_bind.h"
 					>
 				</File>
 			</Filter>
 			<Filter
-				Name="tolua"
-				>
-				<File
-					RelativePath="..\..\src\orxonox\tolua\tolua_bind.h"
-					>
-				</File>
+				Name="overlays"
+				>
+				<File
+					RelativePath="..\..\src\orxonox\overlays\OrxonoxOverlay.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\orxonox\overlays\OverlayGroup.h"
+					>
+				</File>
+				<Filter
+					Name="hud"
+					>
+					<File
+						RelativePath="..\..\src\orxonox\overlays\hud\HUDBar.h"
+						>
+					</File>
+					<File
+						RelativePath="..\..\src\orxonox\overlays\hud\HUDFPSText.h"
+						>
+					</File>
+					<File
+						RelativePath="..\..\src\orxonox\overlays\hud\HUDNavigation.h"
+						>
+					</File>
+					<File
+						RelativePath="..\..\src\orxonox\overlays\hud\HUDRTRText.h"
+						>
+					</File>
+					<File
+						RelativePath="..\..\src\orxonox\overlays\hud\HUDSpeedBar.h"
+						>
+					</File>
+					<File
+						RelativePath="..\..\src\orxonox\overlays\hud\HUDText.h"
+						>
+					</File>
+					<File
+						RelativePath="..\..\src\orxonox\overlays\hud\OverlayElementFactories.h"
+						>
+					</File>
+					<File
+						RelativePath="..\..\src\orxonox\overlays\hud\RadarObject.h"
+						>
+					</File>
+					<File
+						RelativePath="..\..\src\orxonox\overlays\hud\RadarOverlayElement.h"
+						>
+					</File>
+				</Filter>
+				<Filter
+					Name="console"
+					>
+					<File
+						RelativePath="..\..\src\orxonox\overlays\console\InGameConsole.h"
+						>
+					</File>
+				</Filter>
 			</Filter>
 		</Filter>