Index: /code/branches/core3/src/audio/AudioIncludes.h
===================================================================
--- /code/branches/core3/src/audio/AudioIncludes.h	(revision 1605)
+++ /code/branches/core3/src/audio/AudioIncludes.h	(revision 1606)
@@ -47,3 +47,3 @@
 #include <vorbis/vorbisfile.h>
 
-#include "core/Error.h"
+#include "util/Error.h"
Index: /code/branches/core3/src/audio/AudioManager.cc
===================================================================
--- /code/branches/core3/src/audio/AudioManager.cc	(revision 1605)
+++ /code/branches/core3/src/audio/AudioManager.cc	(revision 1606)
@@ -34,5 +34,5 @@
 #include "AudioSource.h"
 #include "AudioStream.h"
-#include "core/Error.h"
+#include "util/Error.h"
 #include "util/Debug.h"
 
Index: /code/branches/core3/src/audio/AudioStream.cc
===================================================================
--- /code/branches/core3/src/audio/AudioStream.cc	(revision 1605)
+++ /code/branches/core3/src/audio/AudioStream.cc	(revision 1606)
@@ -29,5 +29,5 @@
 
 #include "util/Debug.h"
-#include "core/Error.h"
+#include "util/Error.h"
 
 namespace audio
Index: /code/branches/core3/src/core/CMakeLists.txt
===================================================================
--- /code/branches/core3/src/core/CMakeLists.txt	(revision 1605)
+++ /code/branches/core3/src/core/CMakeLists.txt	(revision 1606)
@@ -3,5 +3,4 @@
   ConfigValueContainer.cc
   Core.cc
-  Error.cc
   Language.cc
   ObjectListBase.cc
Index: /code/branches/core3/src/core/CorePrereqs.h
===================================================================
--- /code/branches/core3/src/core/CorePrereqs.h	(revision 1605)
+++ /code/branches/core3/src/core/CorePrereqs.h	(revision 1606)
@@ -111,5 +111,4 @@
   class ConsoleCommand;
   class Core;
-  class Error;
   class Executor;
   template <class T>
@@ -158,6 +157,4 @@
   class XMLPortParamContainer;
 
-  struct ObjectListBase::Export;
-
   // input
   //class GUIInputHandler;
Index: de/branches/core3/src/core/Error.cc
===================================================================
--- /code/branches/core3/src/core/Error.cc	(revision 1605)
+++ 	(revision )
@@ -1,59 +1,0 @@
-/*
- *   ORXONOX - the hottest 3D action shooter ever to exist
- *                    > www.orxonox.net <
- *
- *
- *   License notice:
- *
- *   This program is free software; you can redistribute it and/or
- *   modify it under the terms of the GNU General Public License
- *   as published by the Free Software Foundation; either version 2
- *   of the License, or (at your option) any later version.
- *
- *   This program is distributed in the hope that it will be useful,
- *   but WITHOUT ANY WARRANTY; without even the implied warranty of
- *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *   GNU General Public License for more details.
- *
- *   You should have received a copy of the GNU General Public License
- *   along with this program; if not, write to the Free Software
- *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
- *
- *   Author:
- *      Nicolas Perrenoud
- *   Co-authors:
- *      ...
- *
- */
-
-/**
-    @file Error.cc
-    @brief Implementation of the Error class.
-*/
-
-#include "Error.h"
-#include "util/Debug.h"
-
-namespace orxonox
-{
-	Error::Error(std::string errorMsg, int errorCode)
-	{
-		COUT(1) << "############################ "<< std::endl
-							<< "#         Error "<<errorCode<< "          #"<< std::endl
-							<< "############################ "<< std::endl
-							<< "An error occured in Orxonox: "<< std::endl;
-
-		if (errorMsg=="")
-		{
-			switch (errorCode)
-			{
-				case 1:
-					errorMsg = "Some error!";
-					break;
-				default:
-					errorMsg = "Unknown error!";
-			}
-		}
-		COUT(1) << errorMsg << std::endl<< std::endl;
-	}
-}
Index: de/branches/core3/src/core/Error.h
===================================================================
--- /code/branches/core3/src/core/Error.h	(revision 1605)
+++ 	(revision )
@@ -1,52 +1,0 @@
-/*
- *   ORXONOX - the hottest 3D action shooter ever to exist
- *                    > www.orxonox.net <
- *
- *
- *   License notice:
- *
- *   This program is free software; you can redistribute it and/or
- *   modify it under the terms of the GNU General Public License
- *   as published by the Free Software Foundation; either version 2
- *   of the License, or (at your option) any later version.
- *
- *   This program is distributed in the hope that it will be useful,
- *   but WITHOUT ANY WARRANTY; without even the implied warranty of
- *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *   GNU General Public License for more details.
- *
- *   You should have received a copy of the GNU General Public License
- *   along with this program; if not, write to the Free Software
- *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
- *
- *   Author:
- *      Nicolas Perrenoud
- *   Co-authors:
- *      ...
- *
- */
-
-/**
-    @file Error.h
-    @brief Definition of the Error class.
-*/
-
-#ifndef _Error_H__
-#define _Error_H__
-
-#include "CorePrereqs.h"
-
-#include <string>
-
-namespace orxonox
-{
-	class _CoreExport Error
-	{
-	public:
-		Error(std::string errorMsg = "", int errorCode = 0);
-	private:
-
-	};
-}
-
-#endif /* _Error_H__ */
Index: /code/branches/core3/src/util/CMakeLists.txt
===================================================================
--- /code/branches/core3/src/util/CMakeLists.txt	(revision 1605)
+++ /code/branches/core3/src/util/CMakeLists.txt	(revision 1606)
@@ -2,4 +2,5 @@
   ArgReader.cc
   Clipboard.cc
+  Error.cc
   ExprParser.cc
   Math.cc
Index: /code/branches/core3/src/util/Error.cc
===================================================================
--- /code/branches/core3/src/util/Error.cc	(revision 1606)
+++ /code/branches/core3/src/util/Error.cc	(revision 1606)
@@ -0,0 +1,60 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Nicolas Perrenoud
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+    @file Error.cc
+    @brief Implementation of the Error class.
+*/
+
+#include "Error.h"
+#include "Debug.h"
+
+namespace orxonox
+{
+	Error::Error(std::string errorMsg, int errorCode)
+	{
+		COUT(1) << "############################ " << std::endl
+					  << "#         Error " << errorCode << "          #" << std::endl
+						<< "############################ " << std::endl
+						<< "An error occured in Orxonox: " << std::endl;
+
+		if (errorMsg == "")
+		{
+			switch (errorCode)
+			{
+				case 1:
+					errorMsg = "Some error!";
+					break;
+
+				default:
+					errorMsg = "Unknown error!";
+			}
+		}
+		COUT(1) << errorMsg << std::endl << std::endl;
+	}
+}
Index: /code/branches/core3/src/util/Error.h
===================================================================
--- /code/branches/core3/src/util/Error.h	(revision 1606)
+++ /code/branches/core3/src/util/Error.h	(revision 1606)
@@ -0,0 +1,52 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Nicolas Perrenoud
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+    @file Error.h
+    @brief Definition of the Error class.
+*/
+
+#ifndef _Error_H__
+#define _Error_H__
+
+#include "UtilPrereqs.h"
+
+#include <string>
+
+namespace orxonox
+{
+	class _UtilExport Error
+	{
+	public:
+		Error(std::string errorMsg = "", int errorCode = 0);
+	private:
+
+	};
+}
+
+#endif /* _Error_H__ */
Index: /code/branches/core3/src/util/UtilPrereqs.h
===================================================================
--- /code/branches/core3/src/util/UtilPrereqs.h	(revision 1605)
+++ /code/branches/core3/src/util/UtilPrereqs.h	(revision 1606)
@@ -62,8 +62,8 @@
 class ArgReader;
 class Convert;
+class ExprParser;
 class MultiTypePrimitive;
 class MultiTypeString;
 class MultiTypeMath;
-class OutputHandler;
 class SubString;
 
@@ -72,4 +72,6 @@
     class OutputBuffer;
     class OutputBufferListener;
+    class Error;
+    class OutputHandler;
 }
 
Index: /code/branches/core3/visual_studio/vc8/core.vcproj
===================================================================
--- /code/branches/core3/visual_studio/vc8/core.vcproj	(revision 1605)
+++ /code/branches/core3/visual_studio/vc8/core.vcproj	(revision 1606)
@@ -161,8 +161,4 @@
 			</File>
 			<File
-				RelativePath="..\..\src\core\Error.cc"
-				>
-			</File>
-			<File
 				RelativePath="..\..\src\core\Language.cc"
 				>
@@ -347,8 +343,4 @@
 			</File>
 			<File
-				RelativePath="..\..\src\core\Error.h"
-				>
-			</File>
-			<File
 				RelativePath="..\..\src\core\Language.h"
 				>
Index: /code/branches/core3/visual_studio/vc8/util.vcproj
===================================================================
--- /code/branches/core3/visual_studio/vc8/util.vcproj	(revision 1605)
+++ /code/branches/core3/visual_studio/vc8/util.vcproj	(revision 1606)
@@ -157,4 +157,8 @@
 			</File>
 			<File
+				RelativePath="..\..\src\util\Error.cc"
+				>
+			</File>
+			<File
 				RelativePath="..\..\src\util\ExprParser.cc"
 				>
@@ -215,4 +219,8 @@
 			</File>
 			<File
+				RelativePath="..\..\src\util\Error.h"
+				>
+			</File>
+			<File
 				RelativePath="..\..\src\util\ExprParser.h"
 				>